<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">

 	<xsl:import href="../../base/report/corporate_defaults.xsl"/> 
	<xsl:template name="first_page_frames">
		<frame id="main" x1="2.5cm" y1="3cm" width="23cm" height="16cm"/>
	</xsl:template>
	<xsl:template name="other_page_frames">
		<frame id="main" x1="2.5cm" y1="3cm" width="23cm" height="17cm"/>
	</xsl:template>
	<xsl:template name="first_page_graphics_report"/>
	<xsl:template name="other_pages_graphics_report">
		<drawCentredString x="20.5cm" y="1cm">Pàgina <pageNumber/></drawCentredString>

        </xsl:template>


	<xsl:template match="/">
		<document>
			<template author="Generated by OpenERP-School">
				<xsl:attribute name="pageSize">29.7cm,21cm</xsl:attribute>

				<xsl:attribute name="leftMargin">2cm</xsl:attribute>

				<xsl:attribute name="rightMargin">2cm</xsl:attribute>

				<xsl:attribute name="topMargin">2cm</xsl:attribute>

				<xsl:attribute name="bottomMargin">2cm</xsl:attribute>

				<xsl:attribute name="title">Informe d'absencies per hores</xsl:attribute>

				<pageTemplate id="first_page">
					<pageGraphics>
						<xsl:call-template name="first_page_graphics_corporation"/>
						<xsl:call-template name="first_page_graphics_report"/>
					</pageGraphics>

					<xsl:call-template name="first_page_frames"/>
				</pageTemplate>

				<pageTemplate id="other_pages">
					<pageGraphics>
						<xsl:call-template name="other_pages_graphics_corporation"/>
						<xsl:call-template name="other_pages_graphics_report"/>
					</pageGraphics>

					<xsl:call-template name="other_pages_frames"/>
				</pageTemplate>
			</template>

		<stylesheet>
			<xsl:call-template name="stylesheet"/>
		</stylesheet>

		<story>
			<xsl:call-template name="story"/>
		</story>

		</document>
	</xsl:template>

	<!-- stylesheet -->

	<xsl:template name="stylesheet">
		<blockTableStyle id="linies_participacio_per_grup">
			<blockFont name="Helvetica-Bold" size="5" start="0,0" stop="-1,2"/>
			<blockFont name="Helvetica-Bold" size="6" start="0,2" stop="-1,-1"/>
			<blockBackground colorName="grey" start="0,0" stop="-1,1"/>
			<blockTextColor colorName="white" start="0,0" stop="-1,1"/>
			<blockValign value="MIDDLE"/>
			<blockAlignment value="LEFT" start="0,0" stop="0,-1"/>
			<blockAlignment value="CENTER" start="1,1" stop="-1,-1"/>
			<lineStyle kind="GRID" colorName="black"/>
			<lineStyle kind="OUTLINE" colorName="black" thickness="2" />
			<xsl:for-each select="report/rfpg/dia" >
                        	<xsl:if test="''!=text()">
                        	<lineStyle kind="LINEAFTER" colorName="black" thickness="2" >
                        		<xsl:attribute name="start"><xsl:value-of select="position()-2"/>,0</xsl:attribute>
                        		<xsl:attribute name="stop"><xsl:value-of select="position()-2"/>,-1</xsl:attribute>
                        	</lineStyle>
                        	</xsl:if>
                        </xsl:for-each>
                        <!-- set the left and right padding for cells in first and third columns -->
                        <!-- remember, cell numbering starts from ZERO, not ONE
                        -->
                        <blockLeftPadding length="2" start="0,0" stop="-1,-1"/>
                        <blockRightPadding length="2" start="0,0" stop="-1,-1"/>
                        <blockBottomPadding length="2" start="0,0" stop="-1,-1"/>
                        <blockTopPadding length="2" start="0,0" stop="-1,-1"/>


		</blockTableStyle>
	</xsl:template>


	<xsl:template name="story">
		<xsl:apply-templates select="report/rfpg"/>
	</xsl:template>



	<xsl:template match="rfpg">
            <para fontSize="15" alignement="CENTER" >Informe d'absències per participació i hores</para>
		<spacer length="0.3cm"/>
		<para>
			Data desde <xsl:value-of select="date_from"/>
		</para>
		<para>
			Data fins <xsl:value-of select="date_to"/>
		</para>
		
		<blockTable style="linies_participacio_per_grup" repeatRows="2">
			<tr>
				<xsl:apply-templates select="dia" />
			</tr>
			<tr>
				<xsl:apply-templates select="hora" />
			</tr>
			<xsl:apply-templates select="participation" />
		</blockTable>		
	</xsl:template>

	<xsl:template match="dia">
		<td><xsl:value-of select="."/></td>		
	</xsl:template>
	<xsl:template match="hora">
		<td><xsl:value-of select="."/></td>		
	</xsl:template>
	
	<xsl:template match="participation">
			<tr>
				<td t="1"><xsl:value-of select="name"/></td>
                               		<xsl:apply-templates select="dada_hora" />
			</tr>

	</xsl:template>
	<xsl:template match="dada_hora">
            <td t="1"><xsl:value-of select="."/></td>
	</xsl:template>

</xsl:stylesheet>
