import copy
# -*- encoding: utf-8 -*-
##############################################################################
#
#    school module for OpenERP
#    Copyright (C) 2010 Tecnoba S.L. (http://www.tecnoba.com)
#       Pere Ramon Erro Mas <pereerro@tecnoba.com> All Rights Reserved.
#
#    This file is a part of school modules
#
#    school OpenERP module is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    school OpenERP module is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
import xml.dom.minidom
from report.interface import report_rml
from report.interface import toxml
from comu_resum_faltes import get_part_data,_DISCARD_ABSENCES_SAME_TIME_CONTEXT_KEY

#FIXME: we should use toxml

class report_custom(report_rml):
    def create_xml(self, cr, uid, ids, datas, context={}):
        config = """
        <config>
            <date>09/09/2005</date>
            <PageSize>210.00mm,297.00mm</PageSize>
            <PageWidth>595.27</PageWidth>
            <PageHeight>841.88</PageHeight>
            <tableSize>60.00mm,60.00mm,60.00mm</tableSize>
            <report-header>Resum faltes per grup</report-header>
            <report-footer>Generated by Open ERP</report-footer>
        </config>
        """
        header = """
        <header>
        </header>
        """

        pool=pooler.get_pool(cr.dbname)

        datetime_from=datas['form']['date_from']
        datetime_to=datas['form']['date_to']
        group_ids=datas['form']['group'][0][2]
        parts_by_group={}

        groups=pool.get('groups.group').browse(cr, uid, group_ids, context={'withoutBlank': False})
        part_ids=set()
        for group in groups:
            parts_by_group[group.id]=[]
            for ga in group.assignation_ids:
                if ga.datetime_from<datetime_to and ga.datetime_to>datetime_from:
                    parts_by_group[group.id].append(ga.participation_id.id)
                part_ids.add(ga.participation_id.id)

        context2=copy.deepcopy(context)
        context2[_DISCARD_ABSENCES_SAME_TIME_CONTEXT_KEY]=True
        dicci=get_part_data(cr, uid, list(part_ids), datetime_from, datetime_to, context=context2)
        
        claus=('absent','absent_j','delayed','delayed_j','incidence','expulsion')
        xml=u'<rfpg><date_from>%s</date_from><date_to>%s</date_to>' % (datetime_from,datetime_to)
        group_name=''
        for group in groups:
            data_t=dict.fromkeys(claus, 0)
            xml+="<group><group_name>%s</group_name>" % group.name
            for part_id in sorted(parts_by_group[group.id], key=lambda x:dicci[x]['name']+', '+dicci[x]['first_name']):
                data=dicci[part_id]
                xml+= """<participation>
                <name_student>%s</name_student>
                <first_name_student>%s</first_name_student>
                <total>%s</total><total_just>%s</total_just>
                <delay>%s</delay><delay_just>%s</delay_just>
                <incidence>%s</incidence><expulsion>%s</expulsion>
                </participation>
                """ % (data['name'],data['first_name'],data['total']['absent'],data['total']['absent_j'],data['total']['delayed'],data['total']['delayed_j'],data['total']['incidence'],data['total']['expulsion'],)
                for key in claus: data_t[key]+=data['total'][key]
            xml+= """<total>
            <total>%s</total><total_just>%s</total_just>
            <delay>%s</delay><delay_just>%s</delay_just>
            <incidence>%s</incidence><expulsion>%s</expulsion>
            </total>
            """ % (data_t['absent'],data_t['absent_j'],data_t['delayed'],data_t['delayed_j'],data_t['incidence'],data_t['expulsion'],)
            xml += "</group>"
        if group_name<>'': xml+="</group>"
        xml+= '</rfpg>'           
        xml = u'<?xml version="1.0" encoding="UTF-8" ?>' '<report>'+ config + header + xml + '</report>'
        return self.post_process_xml_data(cr, uid, xml.encode("utf-8"), context)

report_custom('report.school.resum.faltes.per.grup', 'school.group', '', 'addons/school_base/reports/resum_faltes_per_grup.xsl')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

