<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:import href="../../base/report/corporate_defaults.xsl"/>
	<xsl:import href="../../base/report/rml_template.xsl"/>

	<xsl:template name="first_page_frames">
		<frame id="main" x1="1cm" y1="2.5cm" width="19.0cm" height="23cm"/>
	</xsl:template>

	<xsl:template match="/">
		<xsl:call-template name="rml"/>
	</xsl:template>

	<!-- stylesheet -->

	<xsl:template name="stylesheet">
		<blockTableStyle id="resum_faltes_per_grup">
			<blockFont name="Helvetica-Bold" size="10" start="0,0" stop="-1,0"/>
			<blockBackground colorName="grey" start="0,0" stop="-1,0"/>
			<blockTextColor colorName="white" start="0,0" stop="-1,0"/>
			<blockValign value="TOP"/>
			<blockAlignment value="CENTER" start="0,0" stop="-1,0"/>
			<blockAlignment value="RIGHT" start="1,1" stop="-1,-1"/>
			<lineStyle kind="GRID" colorName="black"/>
		</blockTableStyle>
	</xsl:template>

	<xsl:template name="story">
		<xsl:apply-templates select="report/rfpg"/>
	</xsl:template>



	<xsl:template match="rfpg">
		<para>
			Data desde <xsl:value-of select="date_from"/>
		</para>
		<para>
			Data fins <xsl:value-of select="date_to"/>
		</para>
		<xsl:apply-templates select="group"/>
		
	</xsl:template>

	<xsl:template match="group">
		<spacer length="1cm"/>
		<para>GRUP <xsl:value-of select="group_name"/></para>
		<blockTable colWidths="5cm,3cm,1.5cm,2cm,1.5cm,2cm,1.5cm,1.5cm" style="resum_faltes_per_grup" repeatRows="1">
			<tr>
				<td t="1">Cognoms</td>
				<td t="1">Nom</td>
				<td t="1">Abs.</td>
				<td t="1">Abs. no jus.</td>
				<td t="1">Ret.</td>
				<td t="1">Ret. no jus.</td>
				<td t="1">Incid.</td>
				<td t="1">Expul.</td>
			</tr>
			<xsl:apply-templates select="participation" />
                        <xsl:apply-templates select="total" />
		</blockTable>
		
	</xsl:template>
	<xsl:template match="participation">
			<tr>
				<td t="1"><para><xsl:value-of select="name_student"/></para></td>
				<td t="1"><para><xsl:value-of select="first_name_student"/></para></td>
				<td t="1"><xsl:value-of select="total"/></td>
				<td t="1"><xsl:value-of select="total_just"/></td>
				<td t="1"><xsl:value-of select="delay"/></td>
				<td t="1"><xsl:value-of select="delay_just"/></td>
				<td t="1"><xsl:value-of select="incidence"/></td>
				<td t="1"><xsl:value-of select="expulsion"/></td>
			</tr>

	</xsl:template>
	<xsl:template match="total">
			<tr>
				<td t="1"><para>TOTAL</para></td>
				<td t="1"><para></para></td>
				<td t="1"><xsl:value-of select="total"/></td>
				<td t="1"><xsl:value-of select="total_just"/></td>
				<td t="1"><xsl:value-of select="delay"/></td>
				<td t="1"><xsl:value-of select="delay_just"/></td>
				<td t="1"><xsl:value-of select="incidence"/></td>
				<td t="1"><xsl:value-of select="expulsion"/></td>
			</tr>

	</xsl:template>
	
</xsl:stylesheet>
