# -*- encoding: utf-8 -*-
##############################################################################
#
#    school module for OpenERP
#    Copyright (C) 2010 Tecnoba S.L. (http://www.tecnoba.com)
#       Pere Ramon Erro Mas <pereerro@tecnoba.com> All Rights Reserved.
#
#    This file is a part of school modules
#
#    school OpenERP module is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    school OpenERP module is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
from datetime import datetime, timedelta
import xml.dom.minidom
from report.interface import report_rml
from report.interface import toxml
from comu_resum_faltes import get_part_data,_DISCARD_ABSENCES_SAME_TIME_CONTEXT_KEY

#FIXME: we should use toxml

class report_custom(report_rml):

    def create_xml(self, cr, uid, ids, datas, context={}):
        config = """
        <config>
            <date>09/09/2005</date>
            <PageSize>210.00mm,297.00mm</PageSize>
            <PageWidth>595.27</PageWidth>
            <PageHeight>841.88</PageHeight>
            <tableSize>60.00mm,60.00mm,60.00mm</tableSize>
            <report-header>Faltes per participacio</report-header>
            <report-footer>Generated by Open ERP</report-footer>
        </config>
        """
        header = """
        <header>
        </header>
        """

        pool=pooler.get_pool(cr.dbname)
        obj_ga=pool.get('groups.group_assignation')

        part_ids=datas['form']['participations'][0][2]
        groups_ids=datas['form']['groups'][0][2]
        datetime_from=datas['form']['date_from']
        datetime_to=datas['form']['date_to']

        if groups_ids:
            ga_ids=obj_ga.search(cr, uid, [('group_id','in',groups_ids),('datetime_from','<',datetime_to),('datetime_to','>',datetime_from)])
            if ga_ids:
                part_ids+=[x for x in [type(x['participation_id'])==type([]) and x['participation_id'][0] or x['participation_id'] for x in obj_ga.read(cr, uid, ga_ids, ['participation_id'])] if x not in part_ids]

        xml=u'<rfpg><date_from>%s</date_from><date_to>%s</date_to><date-create>%s</date-create>' % (datetime_from,datetime_to,datetime.now().strftime('%Y-%m-%d %H:%M:%S'))

        def passa_a_hores(td):
            return (td.seconds + td.days * 24 * 3600)/3600

        context2=copy.deepcopy(context)
        context2[_DISCARD_ABSENCES_SAME_TIME_CONTEXT_KEY]=True
        for (part_id,part_data) in get_part_data(cr, uid, part_ids, datetime_from, datetime_to, context=context2).items():
            xml_lines=u''
            for (ldate,stat) in part_data['by_date'].items():
                if stat['absent'] or stat['delayed'] or stat['incidence'] or stat['expulsion']:
                    xml_lines+=u"""
            <line>
            <date>%s</date>
            <num_seances>%s</num_seances>
            <time_seances>%s</time_seances>
            <absences>%s</absences>
            <absences_j>%s</absences_j>
            <absences_time>%s</absences_time>
            <absences_time_j>%s</absences_time_j>
            <delays>%s</delays>
            <delays_j>%s</delays_j>
            <incidences>%s</incidences>
            <expulsions>%s</expulsions>
            </line>
            """ % (ldate, len(stat['id_sessions']), passa_a_hores(stat['time_seances']), stat['absent'], stat['absent_j'], passa_a_hores(stat['absent_time']), passa_a_hores(stat['absent_time_j']), stat['delayed'], stat['delayed_j'], stat['incidence'], stat['expulsion'],)
            stat=part_data['total']
            xml_total=u"""
<t_num_seances>%s</t_num_seances>
<t_time_seances>%s</t_time_seances>
<t_absences>%s</t_absences>
<t_absences_j>%s</t_absences_j>
<t_absences_time>%s</t_absences_time>
<t_absences_time_j>%s</t_absences_time_j>
<t_delays>%s</t_delays>
<t_delays_j>%s</t_delays_j>
<t_incidences>%s</t_incidences>
<t_expulsions>%s</t_expulsions>
""" % (len(stat['id_sessions']), passa_a_hores(stat['time_seances']), stat['absent'], stat['absent_j'], passa_a_hores(stat['absent_time']), passa_a_hores(stat['absent_time_j']), stat['delayed'], stat['delayed_j'], stat['incidence'], stat['expulsion'],)

            xml+= u"""
<participation id="%(part_id)s">
<name_student>%(name)s</name_student>
<first_name_student>%(first_name)s</first_name_student>
<tutor_name>%(tutor_name)s</tutor_name>
<tutor_first_name></tutor_first_name>
<group_name></group_name>
<lines_presences>%(xml_lines)s</lines_presences>
%(xml_total)s
</participation>
            """ % {'part_id': part_id, 'name': part_data['name'],'first_name': part_data['first_name'], 'tutor_name': part_data['tutor_name'], 'xml_lines': xml_lines, 'xml_total': xml_total}
        xml+= xml_total + u'</rfpg>'
        xml = u'<?xml version="1.0" encoding="UTF-8" ?>' '<report>'+ config + header + xml  + '</report>'
        return self.post_process_xml_data(cr, uid, xml.encode("utf-8"), context)

report_custom('report.school.resum.faltes.per.participacio', 'groups.participation', '', 'addons/school_base/reports/resum_faltes_per_participacio.xsl')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

