# -*- encoding: utf-8 -*-
##############################################################################
#
#    school module for OpenERP
#    Copyright (C) 2010 Tecnoba S.L. (http://www.tecnoba.com)
#       Pere Ramon Erro Mas <pereerro@tecnoba.com> All Rights Reserved.
#
#    This file is a part of school modules
#
#    school OpenERP module is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    school OpenERP module is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
import xml.dom.minidom
from report.interface import report_rml
from report.interface import toxml

#FIXME: we should use toxml

class report_custom(report_rml):


    def create_xml(self, cr, uid, ids, datas, context={}):
        config = """
        <config>
            <date>09/09/2005</date>
            <PageSize>210.00mm,297.00mm</PageSize>
            <PageWidth>595.27</PageWidth>
            <PageHeight>841.88</PageHeight>
            <tableSize>60.00mm,60.00mm,60.00mm</tableSize>
            <report-header>Teacher stats</report-header>
            <report-footer>Generated by Open ERP</report-footer>
        </config>
        """
        header = """
        <header>
        </header>
        """

        query="""

SELECT
	 rp.name,
	 count(*) as total,
	 count(CASE WHEN s.state='closed' THEN 1 ELSE null END) as closed
FROM school_seance as s INNER JOIN school_teacher_seance as ts ON s.id=ts.seance_id INNER JOIN
     school_teacher AS t ON ts.teacher_id=t.id
     res_partner AS rp ON t.partner_id=rp.id
WHERE
   s.date>'%s' AND
   s.date<'%s' AND s.group_id IS NOT NULL
GROUP BY ts.teacher_id, rp.name
ORDER BY rp.name

           """% (datas['form']['date_from'],datas['form']['date_to'],)
        cr.execute(query)
        xml=u'<rfpg><date_from>%s</date_from><date_to>%s</date_to>' % (datas['form']['date_from'],datas['form']['date_to'])
        for (teacher_name,total,closed,) in cr.fetchall():
            xml+= """<teacher_stats>
            <teacher_name>%s</teacher_name>
            <total>%s</total>
            <closed>%s</closed>
            </teacher_stats>
            """ % (teacher_name,total,closed,)
        xml+= '</rfpg>'
        xml = u'<?xml version="1.0" encoding="UTF-8" ?>' '<report>'+ config + header + xml + '</report>'

        return self.post_process_xml_data(cr, uid, xml.encode("utf-8"), context)

report_custom('report.school.sessions.tancades.per.professor', 'school.teacher', '', 'addons/school_base/reports/sessions_tancades_per_professor.xsl')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

