<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:import href="../../base/report/corporate_defaults.xsl"/>
	<xsl:import href="../../base/report/rml_template.xsl"/>

	<xsl:template name="first_page_frames">
		<frame id="main" x1="1cm" y1="2.5cm" width="19.0cm" height="23cm"/>
	</xsl:template>

	<xsl:template match="/">
		<xsl:call-template name="rml"/>
	</xsl:template>

	<!-- stylesheet -->

	<xsl:template name="stylesheet">
		<blockTableStyle id="sessions_tancades_per_professor">
			<blockFont name="Helvetica-Bold" size="10" start="0,0" stop="-1,0"/>
			<blockBackground colorName="grey" start="0,0" stop="-1,0"/>
			<blockTextColor colorName="white" start="0,0" stop="-1,0"/>
			<blockValign value="TOP"/>
			<blockAlignment value="CENTER" start="0,0" stop="-1,0"/>
			<blockAlignment value="RIGHT" start="1,1" stop="-1,-1"/>
			<lineStyle kind="GRID" colorName="black"/>
		</blockTableStyle>
	</xsl:template>

	<xsl:template name="story">
		<xsl:apply-templates select="report/rfpg"/>
	</xsl:template>



	<xsl:template match="rfpg">
		<para>
			Data desde <xsl:value-of select="date_from"/>
		</para>
		<para>
			Data fins <xsl:value-of select="date_to"/>
		</para>
		<blockTable colWidths="5cm,1.5cm,2cm" style="sessions_tancades_per_professor" repeatRows="1">
			<tr>
				<td t="1">Cognoms</td>
				<td t="1">Sessions</td>
				<td t="1">Tancades</td>
			</tr>
		<xsl:apply-templates select="teacher_stats"/>
		</blockTable>
		
	</xsl:template>
	<xsl:template match="teacher_stats">
			<tr>
				<td t="1"><para><xsl:value-of select="teacher_name"/></para></td>
				<td t="1"><xsl:value-of select="total"/></td>
				<td t="1"><xsl:value-of select="closed"/></td>
			</tr>
		
	</xsl:template>
	
</xsl:stylesheet>
